<template>
  <div>
  <input type="text" class="todo-input" placeholder="What needs to be done" v-model="newToDo" @keyup.enter="addToDo" >
  <div v-for="(todo,index) in todos" :key="todo.id" class="todo-item">
      <div class="todo-item-left">
          <input type="checkbox" v-model="todo.completed">
          <div v-if="!todo.editing" @dblclick="editToDo(todo)"  class="todo-item-label" :class="{completed : todo.completed}">{{todo.title}}</div>
          <input v-else type="text" v-model="todo.title" class="todo-item-edit" @blur="doneEdit(todo)" @keyup.enter="doneEdit(todo)" @keyup.esc="cancelEdit(todo)">
          </div>
      <div class="remove-item" @click="removeToDo(index)">
        x
      </div>
      </div>
  </div>

</template>

<script>
export default {
  name: 'todolist',
  data () {
    return {
      newToDo: '',
      idForToDo: 3,
      beforeEditCache: '',
      todos:[
          {
              'id':1,
              'title':'Finish Vue ToDo App',
              'completed':false,
              'editing':false,
          },
          {
              'id':2,
              'title':'Make more ToDo Tasks',
              'completed':false,
              'editing':false,
          },
      ]
    }
  },
  methods:{
      addToDo(){
          if(this.newToDo.trim().length== 0){
              return
          }
          this.todos.push({id:this.idForToDo, title:this.newToDo,completed:false,editing:false,})
          this.newToDo=''
          this.idForToDo++
      },
      removeToDo(index){
          this.todos.splice(index,1)
      },
      editToDo(todo){
          this.beforeEditCache=todo.title
          todo.editing=true

      },
      doneEdit(todo){
          if(todo.title.trim().length== 0){
              todo.title=this.beforeEditCache
          }
          todo.editing=false
      },
      cancelEdit(todo){
          todo.title=this.beforeEditCache
          todo.editing=false
          
      }
  },
  watch:{
    todos:{
      handler(){
        localStorage.setItem('todos',JSON.stringify(this.todos))

      },
      deep: true
    }
  },
  mounted(){
    if(localStorage.getItem("todos")){
      this.todos = JSON.parse(localStorage.getItem("todos"))
    }
  }
}
</script>


<style>
.todo-input{
    width:100%;
    padding: 10px 18px;
    font-size: 18px;
    margin-bottom: 16px;
}
.todo-item{
    margin-bottom: 12px;
    display: flex;
    align-items: center;
    justify-content: space-between;
}
.remove-item{
    cursor: pointer;
    margin-left: 14px;
}
.todo-item-left{
    display: flex;
    align-items: center;
}
.todo-item-label{
    padding: 10px;
    border: 1px solid white;
    margin-left: 12px;
    
}
.todo-item-edit{
    font-size:24px;
    color:#2c3e58;
    margin-left: 12px;
    width:100%;
    padding: 18px;
    border:1px solid #ccc;

    
}
.completed{
    text-decoration: line-through;
    color:gray;
}
</style>
